from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    n = int(input())
    f = int(input())
    assert f == 1
    d = list(map(int, input().split()))

    def rec(current_diff, start_diff, min_velocity=0, current_velocity=0, start=False):
        # print(f"Checking {current_diff} {start_diff} {min_velocity} {current_velocity} {start}")

        if abs(d[(current_diff + 1) % n] - 1) > current_velocity:
            incrementer = abs(abs(d[(current_diff + 1) % n] - 1) - current_velocity)
            min_velocity += incrementer
            current_velocity += incrementer
            # print(f"Increase velocity for {start_diff} to {min_velocity}")
            return rec(current_diff, start_diff, min_velocity, current_velocity, start)

        current_velocity += 1

        if current_diff % n == start_diff and not start:
            # print(f"If start is {start_diff}, then velocity={min_velocity}")
            return min_velocity

        return rec(current_diff + 1, start_diff, min_velocity, current_velocity)

    # possible = [rec(i, i, min_velocity=d[i], current_velocity=d[i], start=True) for i in range(n)]
    # minimum = min(possible)
    # print(minimum, possible.index(minimum) + 1)
    print(rec(1, 1, 1, 1, start=True))
    print(1)
    pass


thread = threading.Thread(target=main)
thread.start()
