#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long

bool comparator(const pair<int, int> &a, const pair<int, int> &b) {
    return ((double)a.first / a.second > (double)b.first / b.second);
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> b(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++) cin >> b[i];
    vector<pair<int, int>> r;
    for(auto i : a) {
        for(auto j : b) {
            int g = gcd(i, j);
            r.emplace_back(pair<int, int>{i / g, j / g});
        }
    }

    sort(r.rbegin(), r.rend(), comparator);

    for(int j = 0; j < q; j++) {
        int test;
        cin >> test;
        cout << r[test - 1].first << " " << r[test - 1].second << '\n';
    }

    return 0;
}
