#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    map<int, pair<int, vector<int>>> tree;
    map<int, int> costs;
    for (int i = 0; i < n - 1; i++) {
        int vortex, weight;
        cin >> vortex >> weight;
        costs[i + 2] = weight;
        if (!tree.count(vortex)) tree[vortex] = pair<int, vector<int>>{weight, {}};
        if (vortex != i + 2) {
            tree[vortex].second.emplace_back(i + 2);
        }
    }

    int max_channels = 0;
    int cost = 0;

    for (const auto &i: tree) {
        vector<int> empty_vortexes;
        for (auto vortex: i.second.second) {
            if (!tree.count(vortex) or tree[vortex].second.size() + 1 <= k) {
                empty_vortexes.emplace_back(costs[vortex]);
            }
        }
        sort(empty_vortexes.begin(), empty_vortexes.end());
        for (int j = 0; j < min((int) empty_vortexes.size(), k); j++) {
            max_channels++;
            cost += empty_vortexes[j];
        }
    }

    cout << max_channels << " " << cost;


    return 0;
}
